// TsDescrambler.h: CTsDescrambler NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSDESCRAMBLER_H_)
#define _TSDESCRAMBLER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "IMediaDecoder.h"
#include "TsStream.h"
#include "TsTable.h"
#include "BcasCardM.h"
#include "BcasCard.h"
#include "Multi2Decoder.h"


using std::vector;


/////////////////////////////////////////////////////////////////////////////
// MULTI2XNu(ECMɂyC[h̃XNu)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CTsPacket		ÍTSpPbg
// Output	#0	: CTsPacket		TSpPbg
/////////////////////////////////////////////////////////////////////////////

class CTsDescrambler : public IMediaDecoder  
{
public:
	CTsDescrambler();
	virtual ~CTsDescrambler();

// IMediaDecoder
	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const;
	virtual const DWORD GetOutputNum(void) const;

	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0);

// CDeScrambler
	const bool OpenBcasCard(DWORD *pErrorCode = NULL);
	void CloseBcasCard(void);
	const bool GetBcasCardID(BYTE *pCardID);

	const DWORD GetInputPacketCount(void) const;
	const DWORD GetOutputPacketCount(void) const;

protected:
	const bool ProcPatPacket(const CTsPacket *pTsPacket);
	const bool ProcPmtPacket(const CTsPacket *pTsPacket);
	const bool ProcEcmPacket(const CTsPacket *pTsPacket);

	void OnPmtUpdate(const CPmtTable &PmtTable);
	CMulti2Decoder * GetDecoderByPID(const WORD wPID);
	const bool DescramblePacket(CTsPacket *pTsPacket);

	static void CALLBACK OnEcmSection(const CPsiSection *pSection, const PVOID pParam);

	struct TAG_PMTSET
	{
		WORD wPmtPID;
		CPmtTable PmtTable;
	};

	struct TAG_ECMSET
	{
		WORD wEcmPID;
		CPsiSectionParser EcmSectionParser;
		CPsiSection LastEcmSection;
		CMulti2Decoder Decoder;
	};

	CPatTable m_PatTable;
	vector<TAG_PMTSET> m_PmtList;
	vector<TAG_ECMSET> m_EcmList;

	WORD m_awEcmPidMap[0x2000];

#if 1		// [_gA`[ĩ[_gB̂ƂrB
	CBcasCardM m_BcasCard;		//`[i[g
#else
	CBcasCard m_BcasCard;		//O[_g
#endif
	WORD m_wEcmSetIndex;

	DWORD m_dwInputPacketCount;
	DWORD m_dwOutputPacketCount;
};

#endif // !defined(_TSDESCRAMBLER_H_)
