#include "stdafx.h"
#include "RingBuffer.h"

CRingBuffer::CRingBuffer(ULONG size)
{
	m_size = 0;
	m_read = 0;
	m_write = 0;
	m_max = size;

	m_ptr = new char[size];
}

CRingBuffer::~CRingBuffer()
{
	delete [] m_ptr;
}

void CRingBuffer::set(BYTE* data,ULONG size)
{
	m_size += size;

	if(m_write + size >= m_max){		//RINGׂƂ
		ULONG modlen = m_max - m_write;
		memcpy((void*)&m_ptr[m_write],(void*)data,modlen);
		m_write = 0;
		size = size - modlen;
		data += modlen;
	}
	memcpy((void*)&m_ptr[m_write],data,size);
	m_write += size;
}

void CRingBuffer::get(BYTE* data,ULONG size)
{
	if(m_read + size >= m_max){		//RINGׂƂ
		ULONG modlen = m_max - m_read;
		memcpy((void*)data,(void*)&m_ptr[m_read],modlen);
		size = size - modlen;
		data += modlen;
		memcpy(data,(void*)&m_ptr[0],size);
		return;
	}
	memcpy(data,(void*)&m_ptr[m_read],size);
}

void CRingBuffer::flash(ULONG size)
{
	m_size -= size;
	
	if(m_read + size >= m_max){		//RINGׂƂ
		ULONG modlen = m_max - m_read;
		m_read = 0;
		size -= modlen;
	}
	m_read += size;
}
